#include "assessTime.h"
/* 
        There can be a calls to few special function names in the C code --
                void max_loop_count(long int a);
                void max_time(long int a);
                void max_depth(long int a);


                void state1();
*/

/* Implementation details 

   MININT is used as the cost of those rtl expressions which
   Should not be used. 
   By default rest of the expressions will have
   BOT (\bot) as the value.
*/
int global_freq_max;
struct cost_cache{
        char fname[MAX_FUNC_LEN];
        long long int cost;

} *known;
int max_n;

Transition trans[AUTODIFF*AUTODIFF/2 + DELTA];
int ntrans;

/*long int atc_val[(DELTA+AUTODIFF)*BUF_SIZE][BUF_SIZE];*/

NodeCond *ND;

int syn_rcvd_nd = -1;
int process_end_nd = -1;




const char *const annot[] = { PROCESS_BEGIN ,
PROCESS_END ,
SYN_RECV_START,
SYN_RECV_END};
const int num_annot = 4;

long long int cost_tih;
/* Cost of timer interrupt handler */

char *zero_first_guard; 
/* The guard to be used between ZERO and FIRST */

char COSTS_FILE[2000],
     COSTS_OUT_FILE[2000];
int LOOP_DEPTH;
int BUF_SIZE;
long long int TIMER_PERIOD;

/*#undef DATA_COLLECTION_DBG
*/
#undef DATA_COLLECTION
#define SIMHOST_COMPARE
/* Entry point to this file. */
void do_time_assessment(){
        /* 
        We assume that there is no cache. Each memory read is done in
        multiples of 32bit words (Any read for a sub word, is assumed to
        take same amount of time). Similarly each memor write is done in
        multples of 32 bit words.(Any write of a sub word, is assumed to
        take same amount of time). We attach fixed costs to 32 bit reads
        and writes.

        Each rtl level op (excluding the call_insts) has a fixed cost
        attached to it and is given by the constant map:

        baseCost \subseteq op -> int 
        // This is given by ix86_cost.cost


        We have one more map `cost' that gives the cost of each RTL
        instruction.

        timeVal: int | T<int> + timeVal | bot
        cost \subseteq Label -> timeVal

        Then we have a function:

        solve : costFunc -> costFunc'

        such that costFunc' does not have any unknown timeVals. i.e. Has
        only integers as values.

        */
        
        /* Algorithm:

           For each function do: // We are anyway part of an intra
                                 // procedural analysis.
                For each basic block do:
                        freq = get_frequency();
                        cur_cost=get_cost_of_basic_block();
                        total += update_with_frequency(cur_cost, freq);
        
           Output total;
        */

        int automata;
        long long int a1_cost,a2_cost,a3_cost,a4_cost;


        do_init();
        if (strcmp(getenv("TIME_ASSESS"),"DATA_COLLECTION")==0){
                if (read_known_costs() == MATCH_FOUND)
                        return;

                if (assess_time() != SUCCESS)
                        return;

                return;
        }
        
        read_known_costs();
        myassert(my_n_bb < AUTODIFF/4,
                "Need to change the #defined constants");


        cost_tih=get_func_cost(getenv("funcA4"));

/*        a1_cost=get_func_cost("sys_mbox_fetch");*/
        a1_cost=get_func_cost(getenv("funcA1"));
        a1_cost=a1_cost + (a1_cost * cost_tih)/TIMER_PERIOD;

/*        a2_cost=get_func_cost("loop_body") ;*/
        a2_cost= get_func_cost(getenv("funcA2"));
        a2_cost=a1_cost + a2_cost + (a2_cost * cost_tih) / TIMER_PERIOD;

/*        a3_cost=get_func_cost("memp_freep") ;*/
        a3_cost=get_func_cost(getenv("funcA3"));
        a3_cost=a3_cost + (a3_cost * cost_tih) / TIMER_PERIOD;

/*        a4_cost=get_func_cost("post_packet_queue_chores");*/
        a4_cost=get_func_cost(getenv("funcA5"));
        a4_cost=a2_cost + a4_cost + (a4_cost * cost_tih) / TIMER_PERIOD;

        set_max_cost(XN1,a1_cost);
        set_max_cost(XN2,a2_cost - a3_cost);
        set_max_cost(XN3,a2_cost );

        /* If the time_out time is smaller than a4_cost, then there can be
           no progress.

           We need 3 main nodes:
           XN1
           XN2
           XN3

           There will surely be some extra nodes, but that's not the point
           here.
        */
        add_transitions(FIRST,XN1,A0A1);
        add_transitions(XN1,XN2,A1A2);
        add_transitions(XN2,XN3,A2A3);
        add_transitions(FIRST,BAD_NODE,A0);
        add_transitions(XN1,BAD_NODE,A1);
        add_transitions(XN2,BAD_NODE,A2);
        add_transitions(XN3,BAD_NODE,A3);


        zero_first_guard =  (char *)mycalloc(100,sizeof(char));
        sprintf(zero_first_guard,"T_o >= %Ld",
                        a4_cost*FACTOR/BASE);

       {
        /* This block adds edges from the last block, back to the start node.
         * After all we are talking about a packet processing loop.
         */
                FOR_EACH_AUTOMATA {
                        
                        Cond *cond;
                        int ci ;
                        
                        ci = make_timer_interaction_cond(0+tdiCount,
                                                         &cond);
                        timer_default_increment2(XN3,
                                                automata,
                                                &cond[ci]);
                        ci += tdiCount;
                        /* From these leaf nodes, we will goto the first
                         * node only after enough time has passed that the
                         * next packet has come! Instead of waiting in the
                         * 'FIRST' node, we will move from here only after
                         * enough time has passed. For this to come good, we 
                         * will make a temporary node for each of these leaf
                         * nodes and will wait in that node for the time
                         * to pass.
                         */

                        create_edge(XN3+NC, (LEAF_NEXT(XN3)) + NC, cond, ci);

                        /* Don't need to add code to increment
                         * global_timer. It is a waste here. */
                        make_edges_for_end_of_processing_to_loop_back(
                                        LEAF_NEXT(XN3) + NC,
                                        LEAF_NEXT2(XN3) + NC,
                                        FIRST+NC,
                                        TEMP1,
                                        TEMP1,
                                        automata + 1 == BUF_SIZE);

                }
        }

        build_atc(XN2) ; 

/*        add_timeout_edges(XN2);*/

        do_nothing(TIME_OUT,TIMER_PERIOD, BUF_SIZE,T_1,T_U);
        /*printf("\nBB Count = %d\n",cur_bb_count);*/
        /*print_cost(total_tv);*/
        /*deallocate_timeVal(total_tv);*/


} /* do_time_assessment */

/* Build automata transfer constraints and edges */
void build_atc(int bb){
        Cond *cond;
        int automata;
        int ci = 0;
        int b = bb;
        {
        
                FOR_EACH_AUTOMATA {
                        ci = 0;
                        ci = make_timer_interaction_cond(
                                                         3 + tdiCount,
                                                         &cond);


                        timer_default_increment(b,
                                                automata,
                                                &cond[ci]);
                        ci+= tdiCount;
                        create_guard(&cond[ci],  "input &gt;= 1");
                        ci++;

                        create_guard(&cond[ci],  
                                     "T_s0 &lt; T_o and T_s0 &lt;= T_a");
                        ci++;

                        if (automata + 1 < BUF_SIZE){
                                create_edge(b+NC,
                                        FIRST+NCI(automata+1),cond,ci);
                        }
                        else
                                create_edge(b+NC,
                                        ERR2 , cond,ci);
                }
        }
        
}
int assess_time(){
        CGR * cgr;
        FILE *fout ;
        char *vf;
        long long int max_cost;
        fout=fopen(COSTS_OUT_FILE,"a");
        myassert(fout!=NULL,"Could not open COSTS_OUT_FILE");


/*        cgr=do_BFT(make_wl(ENTRY_BLOCK_PTR));*/
/*        if (cgr != NULL)*/
/*                print_CGR(fout,cgr);*/
        vf=(char *)mycalloc(my_n_bb+DELTA,sizeof(char));
        max_cost = do_DFT(ENTRY_BLOCK_PTR,vf);

        if (max_cost != -1)
                fprintf(fout,"%s %Ld\n",IDENTIFIER_POINTER (DECL_NAME
                        (current_function_decl)),
                        max_cost);

        fclose(fout);
        return SUCCESS;
}
void print_CGR(FILE *fout, CGR *cgr){
        fprintf(fout,"%s %Ld\n",IDENTIFIER_POINTER (DECL_NAME
                        (current_function_decl)),
                        cgr->cost);
}
worklist *make_wl(basic_block b){
        worklist *wl = (worklist *)mycalloc(1,sizeof(worklist));

        wl->bb = b;
        wl->next = NULL;
        return wl;
}
boolean dft_visited(basic_block bb,char *vf){
        return (boolean)vf[BBID(bb)];
}
long long int do_DFT(basic_block head, char *vf){
        basic_block bb,start;
        edge e;
        long long int max_cost = 0;
        long long int cur_cost = 0;
        long long int down_cost = 0;
        char *new_vf;

        new_vf = (char *)mycalloc(my_n_bb + DELTA,
                                             sizeof(char));

        for (e=head->succ;e!=NULL;e=e->succ_next){
                bb = e->dest;
                if (invalid_bb(bb))
                        continue;
                if (dft_visited(bb,vf))
                        continue;

                if ((cur_cost=return_bb_max_cost(BBID(bb)))==0){
                        memcpy(new_vf,vf,my_n_bb+DELTA);
                        new_vf[BBID(bb)]=1;
                        cur_cost=compute_cost(bb) ;
                        if (cur_cost == (long long)-1)
                                return -1;
                        down_cost = do_DFT(bb, new_vf);
                        if (down_cost == -1)
                                return -1;
                        cur_cost += down_cost;
                        set_max_cost(BBID(bb),cur_cost);
                }
                if (max_cost < cur_cost)
                        max_cost = cur_cost;
        }
        free(new_vf);
        return max_cost;
 
}
/* Does breadth first traversal of the code and gets the cost of each
 * basic block. With each basic block we also store the maximum of the
 * costs of the basic blocks in the current level.
 */
boolean *visit_flag;
CGR* do_BFT(worklist *wl){
        basic_block bb,start;
        worklist *new_wl;
        edge e;
        CGR *cgr;
        long long int max_cost=0; /* Max cost among children of a node */
        long long int max_cost2 = 0; /* Max of the level */
        long long int cur_cost = 0;

        cgr = (CGR *)mycalloc(1,sizeof(CGR));
        visit_flag=(boolean *)mycalloc(my_n_bb+DELTA,sizeof(boolean));

        do {
                new_wl = NULL;
                while (wl){

                        start = wl->bb;
                        if (!visited(start->index)){
                                set_visited(start->index);
                                
                        } else {
                                
                                wl = wl->next;
                                continue;
                        }
                                

                        max_cost = 0;
/*                        if (is_leaf(start) && */
/*                        check_presence(leaf_bb_wl,wl->bb) == NOT_FOUND)*/
/*                                add_bb_to_wl(&leaf_bb_wl,start);*/

                        for (e=start->succ;e!=NULL;e=e->succ_next){
                                bb = e->dest;
                                if (invalid_bb(bb))
                                        continue;
                                cur_cost=compute_cost(bb);
                                if (cur_cost == (long long)-1)
                                        return NULL;
                                set_cost(bb->index, (cur_cost));
                                        
                                max_cost=(cur_cost > max_cost)?
                                        cur_cost:max_cost;

                        }
                        max_cost2 = (max_cost > max_cost2)?
                                max_cost:max_cost2;
                        for (e=start->succ;e!=NULL;e=e->succ_next){
                                bb = e->dest;
                                if (invalid_bb(bb))
                                        continue;
                                if (cgr->cost + max_cost >
                                    return_bb_max_cost(bb->index)){
                                        if (e->flags & EDGE_DFS_BACK){
                                                set_max_cost(bb->index,
                                                   cgr->cost + max_cost);
                                                set_loop(bb->index);
                                                
                                        }
                                        else{
                                                set_max_cost(bb->index,
                                                   cgr->cost + max_cost);
                                                reset_visited(bb->index);
                                                
                                        }
                                }
                        }
                        for (e=start->succ;e!=NULL;e=e->succ_next){
                             if (invalid_bb(bb))
                                     continue;
                             if (!visited(e->dest->index))
                                     add_bb_to_wl(&new_wl,e->dest);
                        }
                        wl = wl->next;
                }
                wl = new_wl;
                cgr->cost += max_cost2 ;
                max_cost2 = 0;
        } while (new_wl != NULL);

        deallocate_visited_flag();
        return cgr;
        
}
boolean visited(int bb){
        int n=BBINDX(bb);
        myassert(n >= 0 && n < (my_n_bb + DELTA), "Danger");
        return visit_flag[n];
}

void reset_visited(int bb){
        int n=BBINDX(bb);
        myassert(n >= 0 && n < my_n_bb + DELTA, "Danger");
        visit_flag[n]= false;
}
void set_visited(int bb){
        int n=BBINDX(bb);
        myassert(n >= 0 && n < my_n_bb + DELTA, "Danger");
        visit_flag[n]= true;
}

void deallocate_visited_flag(){
        free(visit_flag);
}
void deallocate_wl(worklist *wl){
        if (wl){
                deallocate_wl(wl->next);
                free(wl);
        }
}
void set_cost(int bb, long long int cost){
        int b=BBINDX(bb);
        myassert(b >= 0 && b < my_n_bb + DELTA, "Danger");
        bb_cost[b].cost=cost;
        return;
}
long long int return_bb_cost(int bb){
        
        int b=BBINDX(bb);
        myassert(b >= 0 && b < my_n_bb + DELTA, "Danger");
        return bb_cost[b].cost;
}
long long int return_bb_max_cost(int bb){
        /* sanitized */
        return bb_cost[bb].mcost;
}
boolean is_annotation(const char *fname){
        int i;
        for (i=0;i<num_annot;++i){
                if (strcmp(fname,annot[i])==0)
                        return true;
        }
        return false;
}
long long int get_rtx_cost(rtx x, 
                           enum rtx_code outer_code ATTRIBUTE_UNUSED){
  int i, j;
  enum rtx_code code;
  const char *fmt;
  int total;

  if (x == 0)
    return 0;

  /* Compute the default costs of certain things.
     Note that RTX_COSTS can override the defaults.  */

  code = GET_CODE (x);
  switch (code)
    {
    case MULT:
      total = COSTS_N_INSNS (5);
      break;
    case DIV:
    case UDIV:
    case MOD:
    case UMOD:
      total = COSTS_N_INSNS (7);
      break;
    case USE:
      /* Used in loop.c and combine.c as a marker.  */
      total = 0;
      break;

    case CALL_INSN:
    case JUMP_INSN:
    case RETURN:
    case CALL:
        total = COSTS_N_INSNS (CALL_COST);
        break;
    case MEM:
        total = COSTS_N_INSNS (2);
        break;
    default:
      total = COSTS_N_INSNS (1);
    }

  switch (code)
    {
    case REG:
      return 0;

    case SUBREG:
      /* If we can't tie these modes, make this expensive.  The larger
	 the mode, the more expensive it is.  */
      if (! MODES_TIEABLE_P (GET_MODE (x), GET_MODE (SUBREG_REG (x))))
	return COSTS_N_INSNS (2
			      + GET_MODE_SIZE (GET_MODE (x)) / UNITS_PER_WORD);
      break;

#ifdef RTX_COSTS
      RTX_COSTS (x, code, outer_code);
#endif
#ifdef CONST_COSTS
      CONST_COSTS (x, code, outer_code);
#endif
    default:
#ifdef DEFAULT_RTX_COSTS
      DEFAULT_RTX_COSTS (x, code, outer_code);
#endif
      break;
    }

  /* Sum the costs of the sub-rtx's, plus cost of this operation,
     which is already in total.  */

  fmt = GET_RTX_FORMAT (code);
  for (i = GET_RTX_LENGTH (code) - 1; i >= 0; i--)
    if (fmt[i] == 'e')
      total += get_rtx_cost (XEXP (x, i), code);
    else if (fmt[i] == 'E')
      for (j = 0; j < XVECLEN (x, i); j++)
	total += get_rtx_cost (XVECEXP (x, i, j), code);

  return total;
}
long long int compute_cost(basic_block bb){
        int freq;
        long long int known_max_time=-1;

        long long int cur_bb_cost = 0 ;
        long long int cost = 0;
        rtx insn = bb->head;

        if (bb->index < 0)
                return 0;
        freq = get_frequency(bb);
        for (;insn && insn != NEXT_INSN(bb->end); insn=NEXT_INSN(insn)){

                if (useless_insn(insn))
                        continue;

                if (!call_insn(insn))
                        cost = get_rtx_cost(insn, GET_CODE(insn));
                else {
                        const char *fname = Fname(insn);
                        if (strcmp(fname,maxTime)==0){
                                known_max_time = Farg(insn);
                                continue;
                        }
                        if (known_max_time != (long long)-1){
                               cost = known_max_time;
                        } else{
                                long long int known_cost;
                                if ((known_cost=already_known(fname)) !=(long long)-1)
                                        cost = known_cost;
                                else {
                                        if (!is_annotation(fname))
                                        {
                                        if (getenv("ATASYN_DBG")!=NULL){
                                                fprintf(stdout,
                                                "%s Having trouble with %s\n",
                                                IDENTIFIER_POINTER (DECL_NAME
                                                        (current_function_decl)),
                                                fname);
                                        }
                                                return -1;
                                        }
                                        else {
                                                myassert(0,
                                                        "Marker is around!!");
                                                cost = 0;
                                        }
                                }
                        }
                        known_max_time=-1;
                }

                cur_bb_cost  += cost;
        } /* for each insn in bb */

        cur_bb_cost *= freq;

        return cur_bb_cost;
}
void set_max_cost(int bb, long long int cost){
        int b = BBINDX(bb);

        myassert(b >= 0 && b < my_n_bb + DELTA, "Danger!!");

        bb_cost[b].mcost=cost;
        return;
}
boolean is_loop_head(int bb){
         int b = BBINDX(bb);

        myassert(b >= 0 && b < my_n_bb + DELTA, "Danger!!");

        return bb_cost[b].back_edge_head;
       
}
void set_loop(int bb){
        int b = BBINDX(bb);

        myassert(b >= 0 && b < my_n_bb + DELTA, "Danger!!");

        bb_cost[b].back_edge_head=true;
        return;
}
void add_bb_to_wl(worklist **wl, basic_block bb){
/* It is okay to have *wl as NULL */
        worklist *nwl = make_wl(bb) ;
        nwl -> next = *wl;
        *wl = nwl;

        return;
}
boolean bb_has_useful_inst(basic_block bb){
        rtx insn = bb->head;
        if (bb->index < 0)
                return false;
        for (;insn && insn != NEXT_INSN(bb->end); insn=NEXT_INSN(insn)){

                if (useless_insn(insn))
                        continue;

                return true;
        } 
        return false;
}
void do_init(){

        syn_rcvd_nd = -1;
        process_end_nd = -1;
        ntrans = 0;
        strcpy(COSTS_FILE,getenv("KNOWN_COSTS"));
        strcpy(COSTS_OUT_FILE,getenv("KNOWN_COSTS"));
        LOOP_DEPTH=atoi(getenv("LOOP_DEPTH"));
        BUF_SIZE=atoi(getenv("BUF_SIZE"));
        TIMER_PERIOD=atoi(getenv("TIMER_PERIOD"));

        ND = (NodeCond *)mycalloc((DELTA+AUTODIFF)*BUF_SIZE,sizeof(NodeCond));
        bb_cost = (struct BB_Cost *)mycalloc(my_n_bb+DELTA,sizeof(struct BB_Cost));
}
void add_ncond_to_edge(int bb1, int bb2, Cond *cond, int ncond){

        int i;
        int j;
        boolean edge_found = false;

        if (ncond <= 0)
                return;

        for (i=0;i<ntrans;++i){
        if (trans[i].src == bb1 && trans[i].dest == bb2){

                trans[i].cond = xrealloc(trans[i].cond,
                        (ncond+trans[i].ncond)*sizeof(Cond));

                for (j=0;j<ncond;++j){

                        copy_cond(&(trans[i].cond[trans[i].ncond+j]),
                                  &cond[j]);
                }
                trans[i].ncond += ncond;

                edge_found = true;
                break;
        }
        }
 
        if (!edge_found)
                create_edge(bb1,bb2,cond,ncond);

}
void add_cond_to_edge(int bb1,int bb2, Cond* cond){
/* Adds ONE condition to the edge bb1-bb2 */

        int i;
        boolean edge_found = false;

        for (i=0;i<ntrans;++i){
                if (trans[i].src == bb1 && trans[i].dest == bb2){
                        trans[i].cond = xrealloc(trans[i].cond,
                                (1+trans[i].ncond)*sizeof(Cond));
                        copy_cond(&(trans[i].cond[trans[i].ncond]),cond);
                        trans[i].ncond++;

                        edge_found = true;
                        break;
                }
        }
        if (!edge_found)
                create_edge(bb1,bb2,cond,1);
}
void copy_cond(Cond *dest, Cond *src){
        dest->kind = src->kind;
        dest->pred = src->pred;
}

boolean neighbors(basic_block bb1, basic_block bb2){
        edge e;

        for (e=bb1->succ;e!=NULL;e=e->succ_next){
                if (e->dest->index == bb2->index)
                        return true;
        }
        return false;

}

int check_presence(worklist *wl,  basic_block bb){
        while (wl){
                if (wl->bb == bb)
                        return FOUND;
                wl = wl->next;
        }
        return NOT_FOUND;
}
/* push_conditions_on_path: Returns a work list consisting of all the nodes
 * present in all the paths */
/* This function is a hack! -- It knows that cond[0].pred needs filling */
worklist * push_conditions_on_path(basic_block bb1, 
                basic_block bb2, 
                int automata,
                Cond *cond,
                int ncond,
                worklist *cur_wl){
/* CAN get stuck in a loop. KEEP AN EYE */
        worklist *full_wl = NULL, *wl = NULL;
        edge e;

        if (cur_wl == NULL)
                add_bb_to_wl(&cur_wl,bb1);

        if (neighbors(bb1,bb2)){
                add_ncond_to_edge(bb1->index + NC,
                bb2->index + NC,
                cond, ncond);
                return make_wl(bb2);
        }
        for (e=bb1->succ;e!=NULL;e=e->succ_next){ 
                if (check_presence(cur_wl,e->dest)==FOUND)
                        continue;
                add_bb_to_wl(&cur_wl,e->dest);
                if ((wl=push_conditions_on_path(e->dest, bb2,
                                                automata,
                                                cond,
                                                ncond,
                                                cur_wl)) != NULL){ 
                        add_ncond_to_edge(bb1->index + NC,
                                        e->dest->index + NC,
                                        cond, ncond);
                        add_bb_to_wl(&wl,e->dest);

                        if (full_wl == NULL)
                                full_wl = wl;
                        else{
                                worklist *tmp_wl = full_wl;
                                while (tmp_wl->next){
                                        tmp_wl = tmp_wl -> next;
                                }
                                tmp_wl -> next = wl;
                        }
                        
                }
        }

        return full_wl;
}
        
int add_transitions(int bb1, int bb2, int choice){
        int automata;
        int ci;

        if (choice == A0A1){
                /* bb1 = FIRST, bb2 = node of A1 */
                char *s;
                Cond *cond;
                FOR_EACH_AUTOMATA {

                        int ci = 0;
                        cond = (Cond *)mycalloc(3,sizeof(Cond));
                        s = (char *)mycalloc(100,sizeof(char));
                        sprintf (s,"T_s%d := 0, Ctr%dA2 := 1",
                                   automata,automata);
                        cond[ci].kind = "assignment";
                        cond[ci++].pred = s;

                        s = (char *)mycalloc(100,sizeof(char));
                        sprintf(s, "input &gt;= 1");
                        cond[ci].kind = "guard";
                        cond[ci++].pred = s;

                        cond[ci].kind = "assignment";
                        cond[ci++].pred = "input -= 1";
                        /* Don't need to increment global_timer here as no
                         * change in timers here. */
                        create_edge(bb1 + NC,bb2 + NC,cond,ci);

                } /* FOR_EACH_AUTOMATA */
               return NEEDS_CARE; 
        }
        if (choice == A1A2){
                /* bb1 = node of A1, bb2 = node A2 */

                Cond *cond ;
                char *s;

                FOR_EACH_AUTOMATA{
                        /* Don't need to increment global_timer here as it
                         * is useless here. I am doing it anyways. */
                        ci=0;
                        cond = (Cond *)mycalloc(2,sizeof(Cond));

                        timer_default_increment2(bb1,
                                                automata,
                                                &cond[ci]);
                        ci+= tdiCount;
                        
                        
                        s = (char *)mycalloc(100,sizeof(char));
                        sprintf(s,"T_s0 &gt;= %Ld",(long long)TTL);
                        create_guard(&cond[ci],s);
                        ci++;

                        add_ncond_to_edge(bb1 + NC , TEMP1, cond, ci);

                } /* FOR_EACH_AUTOMATA */


                FOR_EACH_AUTOMATA {

                        ci = 0;
                        cond = (Cond *)mycalloc(2,sizeof(Cond));

                        timer_default_increment2(bb1,
                                                automata,
                                                &cond[ci]);
                        ci+= tdiCount;

                        s = (char *)mycalloc(100,sizeof(char));
                        sprintf(s,"T_s0 &lt;= %Ld",(long long)TTL);
                        create_guard(&cond[ci],s);
                        ci++;

                        create_edge(bb1 + NC,
                                bb2 + NC, cond,ci);
                } /* FOR_EACH_AUTOMATA */
/*                process_end_nd = bb1;*/
/*                syn_rcvd_nd = bb2;*/
                return CARE_TAKEN;
        }
        if (choice == A2A3){
                /* bb1 = node of A2, bb2 = node of A3 */
                FOR_EACH_AUTOMATA {
                        Cond *cond;
                        ci = make_timer_interaction_cond( 0+tdiCount,
                                                         &cond);
                        
                        timer_default_increment(bb1,
                                                automata,
                                                &cond[ci]);
                        ci+=tdiCount;
                        add_ncond_to_edge(bb1 + NC,
                                        bb2 + NC,cond, ci);
                } /* FOR_EACH_AUTOMATA */
                return CARE_TAKEN;
 
        }
        if (choice == A2){
                /* bb1 = Node number` of A2, bb2 = -1. */
                Cond *cond ;
                char *s;

                FOR_EACH_AUTOMATA {
                        /****************************************/
                        /* If a new packet can be availabe while in A2, after
                         * it is placed in buffer then allow it.
                         */
                        ci=0;
                        cond = (Cond *)mycalloc(4,sizeof(Cond));
                        create_guard(&cond[ci], "T_s0 &gt;= T_a");
                        ci++;

                        create_guard(&cond[ci],"T_s0 &lt;= T_o");
                        ci++;

                        create_synchronization(&cond[ci], "input_reset!");  
                        ci++;

                        s=(char *)mycalloc(100,sizeof(char));
                        sprintf(s,
                                "T_s%d &lt;= Ctr%dA2 * timer_period",
                                automata,automata);
                        create_guard(&cond[ci], s);
                        ci++;

                        create_edge(bb1 + NC,
                                        bb1 + NC,cond, ci);
                        /***************************************/
                        ci=0;
                        cond = (Cond *)mycalloc(4,sizeof(Cond));
                        create_guard(&cond[ci], "T_s0 &lt;= T_o");
                        ci++;
                        

                        s=(char *)mycalloc(100,sizeof(char));
                        sprintf(s,
                                "Ctr%dA2 &lt;= (%Ld/timer_period)+1",
                                automata,
                                return_bb_max_cost(bb1)*FACTOR/BASE);
                        create_guard(&cond[ci], s);
                        ci++;


                        s=(char *)mycalloc(100,sizeof(char));
                        sprintf(s,
                                "Ctr%dA2 += 1",
                                automata);
                        create_assignment(&cond[ci], s);
                        ci++;

                        s=(char *)mycalloc(100,sizeof(char));
                        sprintf(s,
                                "T_s%d &gt;= Ctr%dA2 * timer_period",
                                automata,automata);
                        create_guard(&cond[ci], s);
                        ci++;


                        create_edge(bb1 + NC,
                                        bb1 + NC,cond, ci);
                        /***************************************/
                        /* If during the stay in A2, if the first packet
                         * has timed out, then let us not follow this path
                         * and stop.
                         */

                        ci=0;
                        cond = (Cond *)mycalloc(1,sizeof(Cond));

                        create_guard(&cond[ci],"T_s0 &gt;= T_o");
                        ci++;

                        /* whether or not FIRST AUTOMATA, then --> TEMP1 */
                        create_edge(bb1+NC,
                                    TEMP1,
                                    cond,
                                    ci);
                        /***************************************/

                        /* Add edge from current node to TOSTATE */
                        ci = 0;
                        cond = (Cond *)mycalloc(3,sizeof(Cond));

                        s=(char *)mycalloc(100,sizeof(char));
                        sprintf(s,
                                "Ctr%dA2 &gt;= (%Ld/timer_period) + 1",
                                automata,
                                return_bb_max_cost(bb1)*FACTOR/BASE);
                        create_guard(&cond[ci], s);
                        ci++;

                        timer_default_increment(bb1,
                                                automata,
                                                &cond[ci]);
                        ci+= tdiCount;

                        cond[ci].kind = "guard";
                        s = (char *)mycalloc(100,sizeof(char));
                        sprintf(s, "T_s%d &lt; T_o",
                                        automata);
                        cond[ci++].pred = s;

                        create_edge(bb1 + NC, TOSTATE+NC,
                                        cond, ci);
                        /***************************************/

                        /* Add edges from TOSTATE to (a) on input == 3 to
                         * TEMP1 and (b) on T_s_0 < T_o + T_a < intr_ctr *
                         * timer --> FIRST of next/ERR2. (c) T_s_0 > T_o
                         * and T_a < intr_ctr * timer -->  hang_for_good.
                         * (d) T_s0 >= Ta + input_reset! --> TOSTATE2 and
                         * TOSTATE2 --> FIRST like TOSTATE had.
                         * I have done only (b), (c) and (d). TODO (a) 
                         */

                        /* b + c + d*/
                        /* At this stage it is okay to send the timedout
                         * ones to TEMP1, as the case can be modelled by
                         * loss of packets while waiting in the
                         * first/previous thread.
                         */
                        make_edges_for_end_of_processing_to_loop_back(
                                        TOSTATE + NC,
                                        TOSTATE2 + NC,
                                        FIRST+NCI(automata+1),
                                        ERR2,
                                        TEMP1,
                                        automata + 1 == BUF_SIZE);
                } /* FOR_EACH_AUTOMATA */


                return CARE_TAKEN;
        }
        if (choice == A0){
                /* bb1 = FIRST, bb2 = BAD_NODE */
                Cond *cond ;
#ifdef SIMHOST_COMPARE
                /* I want to loop back, only for the first packet. Not for
                 * others. This is to get a match with the simhost. */
                automata = 0;
#endif
#ifndef SIMHOST_COMPARE
                FOR_EACH_AUTOMATA
                {

                        ci = 0;
                        cond = (Cond *)mycalloc(2,sizeof(Cond));
                        create_guard(&cond[ci], "T_s0 &gt;= T_a");
                        ci++;

                        create_synchronization(&cond[ci], "input_reset_a0!");
                        ci++;

                        create_edge(bb1+NC, bb1+NC, cond,ci);
                }
#endif
                return CARE_TAKEN;
        }
        if (choice == A1 || choice == A3){
                /* b1 = node of A1  or  A3, b2 = BAD_NODE */
                Cond *cond;
                char *s;
                FOR_EACH_AUTOMATA{
                        ci=0;
                        cond = (Cond *)mycalloc(4,sizeof(Cond));
                        create_guard(&cond[ci], "T_s0 &gt;= T_a");
                        ci++;

                        create_guard(&cond[ci],"T_s0 &gt;= T_o");
                        ci++;

                        create_synchronization(&cond[ci], "input_reset!");  
                        ci++;

                        s=(char *)mycalloc(100,sizeof(char));
                        sprintf(s,
                                "T_s%d &lt;= %Ld",
                                automata,
                                return_bb_max_cost(bb1)*FACTOR/BASE);
                        create_guard(&cond[ci], s);
                        ci++;


                        create_edge(bb1 + NC,
                                        bb1 + NC,cond, ci);

                        /********************************************/
                        ci=0;
                        cond = (Cond *)mycalloc(1,sizeof(Cond));

                        create_guard(&cond[ci],"T_s0 &gt;= T_o");
                        ci++;

                        /* whether or not FIRST AUTOMATA, then --> TEMP1 */
                        create_edge(bb1+NC,
                                    TEMP1,
                                    cond,
                                    ci);
 
                }
                 
        }
        return CARE_TAKEN;
}
void set_node_condition(int bb_no, Cond *cond,int ncond){

        int b = BBINDX(bb_no);
        ND[b].cond = cond;
        ND[b].ncond = ncond;
}

Cond* ND_cond(int bb_no){
        int b = BBINDX(bb_no);
        return ND[b].cond;
}

int ND_ncond(int bb_no){
        int b = BBINDX(bb_no);
        return ND[b].ncond;
        
}

void add_natural_condition(int bb, int automata){
        int b ; 
        int ncond ;
        char *s ;

        b=bb;
        ncond=ND_ncond(b+NC);
        myassert(b >=0 && b < my_n_bb + DELTA, "Danger");
       
        ND[b + NC].cond = xrealloc(ND_cond(b + NC),
                        (1+ncond)*sizeof(Cond));
        
        s=(char *)mycalloc(100,sizeof(char));
        if (bb == XN2)
        sprintf(s,/*"T_a &lt;= T_a + %Ld and " 
                  "T_s%d &lt;=   T_s%d + %Ld and " */
                  "T_s%d &lt;=    (Ctr%dA2 * timer_period)",
                  automata,  automata);
        else
        sprintf(s, "T_s%d &lt;=    %Ld",
                  automata, return_bb_max_cost(b)*FACTOR/BASE, automata);
        

        ND[b + NC].cond[ncond].kind = "invariant";
        ND[b + NC].cond[ncond].pred = s;
        ND[b + NC].ncond ++;


        if (bb != XN2)
                return;
#if 0
        Not sure, if this is required or not.
        ci = 0;
        cond = (Cond *)mycalloc(2,sizeof(Cond));
        cond[ci].kind = "guard";
        cond[ci++].pred = "T_s0 &gt;= T_a";

        cond[ci].kind = "synchronisation";
        cond[ci++].pred = "input_reset!";

        /* I am not adding the additional guard that input != 1, as we
         * might actually loose some packets when processing the bb
         * atomically.
         */

        create_edge(bb+NC,bb+NC,cond,ci);
#endif        
}

void add_cond_to_node(int bb, int automata, Cond *cond){
/* Add only ONE condition to the node */
        int i;
        int ncond = ND_ncond(bb);
        int b = BBINDX(bb);
        if (cond == NULL)
                return;
        myassert(b >=0 && b < my_n_bb + DELTA, "Danger");
       
        if (automata == FIRST_AUTOMATA) 
                ND[b].cond = xrealloc(ND_cond(b),
                                (1+ncond)*sizeof(Cond));
        else{
                 ND[b + NC].cond = mycalloc( (1+ncond),
                                sizeof(Cond));
                for (i=0;i<ncond+1;++i){
                        copy_cond(&ND[b + NC].cond[i],
                                  &ND[b].cond[i]);
                }
          
        }
        
        copy_cond(&(ND[b + NC].cond[ncond]),cond);
        ND[b + NC ].ncond ++;
        

}
void do_nothing(long long int t_o, long long int timer_period, int
                m, long long int t_1, long long int t_u){
        int i;
        Cond *cond;
        int automata;
        int b;

        prologue();

        {
                Cond *def_cond;

                def_cond = (Cond *)mycalloc(1,sizeof(Cond));
                def_cond[0].kind = "invariant";
                def_cond[0].pred = "T_a &lt;= 0";

                create_and_print_node(ZERO  ,"Heaven",def_cond,1);
        }
        FOR_EACH_AUTOMATA {
                char *s, *s2 = NULL ;
                Cond  *cond;
                int ci;


                ci=0;
                s = (char *)mycalloc(100,sizeof(char));
                sprintf(s,"Monitor%d", automata);

                if (automata >= 1) {
                        s2 = (char *)mycalloc(100,sizeof(char));
                        cond = (Cond *)mycalloc(1,sizeof(Cond));
                        sprintf(s2,"T_s%d &lt;= Ctr%dA2 * timer_period",
                                        automata-1,
                                        automata-1);
                        create_guard(&cond[ci],s2);
                        ci++;
                }
                create_and_print_node(FIRST + NC ,s,cond,ci);

                cond = (Cond *)mycalloc(1,sizeof(Cond));
                cond[0].kind = "guard";
                cond[0].pred = "input == 0";
                create_edge(FIRST + NC, TEMP1, cond,1);

                /* Nodes for TOSTATE */
                cond = (Cond *)mycalloc(1,sizeof(Cond));
                cond[0].kind = "guard";
                s = (char *)mycalloc(100,sizeof(char));
                sprintf(s, "T_s%d &lt;= T_s%d + timer_period",
                                automata, automata);
                cond[0].pred = s;
                s = (char *)mycalloc(100,sizeof(char));
                sprintf(s,"TimeOutSt_%d", automata);
                create_and_print_node(TOSTATE + NC,s,cond,1);

                /* Nodes for TOSTATE2 */
                s = (char *)mycalloc(100,sizeof(char));
                sprintf(s,"TimeOutSt2_%d", automata);
                create_and_print_node(TOSTATE2 + NC,s,NULL,0);

                                
        } /* FOR_EACH_AUTOMATA */
        create_and_print_node(ERR2,"err2",NULL,0);
        create_and_print_node(TEMP1,"hang_for_good",NULL,0);

        
        FOR_EACH_AUTOMATA {
                char *s = (char *)mycalloc(100,sizeof(char));
                sprintf(s,"leafWait1_%d_%d", automata, XN2);
                create_and_print_node(LEAF_NEXT(XN3) + NC,
                                      s, NULL, 0);
                s = (char *)mycalloc(100,sizeof(char));
                sprintf(s,"leafWait2_%d_%d", automata, XN2);
                create_and_print_node(LEAF_NEXT2(XN3) + NC,
                                      s, NULL, 0);
        }
        

        for (b=XN1;b<=XN3;++b){
                FOR_EACH_AUTOMATA {
                        char *s = (char *)mycalloc(100,sizeof(char));
                        add_natural_condition(b,automata);
                        sprintf(s,"Nd%d",b + NC );
                        create_and_print_node(b+NC,s,
                               ND_cond(b+NC),ND_ncond(b+NC));
                }
        } /* FOR_EACH_AUTOMATA */
        cond = (Cond *)mycalloc(2,sizeof(Cond));
        cond[0].kind = "guard";
        cond[0].pred = zero_first_guard;
        cond[1].kind = "assignment";
        cond[1].pred = "T_a := 0, T_s0 := 0, Ctr1A2 := 1";
        create_edge(ZERO ,
                        FIRST ,
                        cond,
                        2);
        set_init(ZERO);
        for (i=0;i<ntrans; ++i){
                print_edge(trans[i].src,
                            trans[i].dest,
                            trans[i].cond,
                            trans[i].ncond);
        }
        end_template();
/*        timer_intr_handler();*/

/*        attacker();*/
/*        epilogue(t_o,timer_period, m,t_1,t_u);*/
        return;
}

void create_edge(int src, int dest, Cond* cond, int ncond){
        if (ncond <= 0)
                return;
        trans[ntrans].src = src;
        trans[ntrans].dest = dest;
        trans[ntrans].cond = cond;
        trans[ntrans++].ncond = ncond;
        

        return;
}
void create_and_print_node(int bb_no, const char *node_name, Cond *cond,int ncond){
        
        
        if (node_name == NULL){
                fprintf(stdout,"<location id=\"id%d\" >",
                                bb_no);
        } else
                fprintf(stdout,
                       "<location id=\"id%d\" > <name>%s</name> ",
                       bb_no,node_name);
        if (cond)
                        print_conditions(cond,ncond);

        fprintf(stdout,"</location>\n");
        return;
}
void set_init(int nd_no){
        
        fprintf(stdout,"<init ref=\"id%d\" />\n",nd_no);
}

void end_template(){
        fprintf(stdout,"</template>\n");
}
void attacker(){
fprintf(stdout,
"<template>\
<name>attacker</name><parameter>const T_1,T_u</parameter>\
<location id=\"id90\"><name >start_evil</name></location>\
<location id=\"id91\" ><name >snore</name></location>\
<location id=\"id92\" ><name >send_packet</name></location> \
<init ref=\"id90\"/> \
<transition> \
<source ref=\"id90\"/><target ref=\"id91\"/> \
<label kind=\"assignment\" >T_a:=0</label> \
</transition>");
fprintf(stdout,
"<transition> \
<source ref=\"id91\"/><target ref=\"id92\"/> \
<label kind=\"guard\" >T_a &gt; T_u</label> \
</transition> \
<transition> \
<source ref=\"id92\"/><target ref=\"id90\"/> \
<label kind=\"guard\" >T_a &gt;= T_1</label> \
<label kind=\"assignment\" >input -= 1 </label> \
 </transition> \
  </template>\n \
");
}
void timer_intr_handler(){

fprintf(stdout,
"<template>\
<name>TimerIntrHandler</name><parameter></parameter>\
<location id=\"Tid90\"><name >start</name></location>\
<location id=\"Tid91\"><name >hurry</name></location>\
<location id=\"Tid92\"><name >Overflow</name></location>\
<init ref=\"Tid90\"/> \n");

fprintf(stdout,
"<transition> \
<source ref=\"Tid90\"/><target ref=\"Tid91\"/> \
</transition>\n");

fprintf(stdout,
"<transition> \
<source ref=\"Tid90\"/><target ref=\"Tid92\"/> \
<label kind=\"guard\" >intr_ticks &gt;= %d </label> \
</transition>\n",
MAX_INTR_CNT);

fprintf(stdout,
"<transition> \
<source ref=\"Tid91\"/><target ref=\"Tid90\"/> \
<label kind=\"guard\" >T_a &gt; intr_ticks * %Ld</label> \
<label kind=\"synchronisation\" >awake_timer?</label> \
<label kind=\"assignment\" >intr_ticks += lost_ticks</label> \
 </transition>\n",
 TIMER_PERIOD);

fprintf(stdout,
"<transition> \
<source ref=\"Tid91\"/><target ref=\"Tid90\"/> \
<label kind=\"guard\" >lost_cycles &gt;= %Ld </label> \
<label kind=\"assignment\" >intr_ticks += 1, lost_cycles -= %Ld</label> \
 </transition>\n", TIMER_PERIOD,TIMER_PERIOD);

fprintf(stdout,
"<transition> \
<source ref=\"Tid91\"/><target ref=\"Tid90\"/> \
<label kind=\"guard\" >T_a &lt;= intr_ticks * %Ld</label> \
<label kind=\"synchronisation\" >input_reset!</label> \
 </transition>\n",TIMER_PERIOD);

fprintf(stdout,
"</template>\n \
");
}
void prologue(){
        int automata;
        
fprintf(stdout,
"<?xml version=\"1.0\"?> \n "
"<!DOCTYPE nta PUBLIC \"-//Uppaal Team//DTD Flat System 1.0//EN\"  \n"
"\"http://www.docs.uu.se/docs/rtmv/uppaal/xml/flat-1_0.dtd\">  \n"
"<nta>\n "
" <declaration>//declarations of global clocks, variables, constants and"
" channels.\n clock ");
FOR_EACH_AUTOMATA {
        fprintf(stdout,
                "T_s%d, ",automata);
}
fprintf(stdout, "T_a; \n int input, intr_ticks, lost_ticks, ");
FOR_EACH_AUTOMATA {
        fprintf(stdout,
                "Ctr%dA2, ",automata);
}
fprintf(stdout, "lost_cycles;\n chan input_reset, input_reset_a0, awake_timer;\n");
                
fprintf(stdout,
"</declaration> \n "
"  <template> \n "
"    <name>server</name> \n "
"    <parameter >const T_o, timer_period</parameter>\n "
"\n");

}
void epilogue(long long int t_o,long long int timer_period, int m,
                long long int t_1, long long int t_u){
        fprintf(stdout,"<instantiation> // Insert process assignments\n");
        fprintf(stdout,"S:=server(%Ld, %Ld);\n",
                        t_o,timer_period);
/*        fprintf(stdout,"S:=server(%lu, %lu, %d, %lu);\n",*/
/*                        t_o,timer_period, m,t_1);*/
/*        fprintf(stdout,"A:=attacker(%lu, %lu);\n",t_1,t_u);*/
        fprintf(stdout,"A:=attacker();\n");
        fprintf(stdout,"</instantiation>\n");
        fprintf(stdout,"<system>system S,A,Tm;\n</system>");
        fprintf(stdout,"</nta>\n");

}
void begin_template(){
        fprintf(stdout,"<template>\n");
}
void print_edge(int bb_s, int bb_d, Cond *cond,int ncond){
        

        fprintf(stdout,
                "<transition><source ref=\"id%d\"/>\
                             <target ref=\"id%d\"/>",
                bb_s,bb_d);
                print_conditions(cond,ncond);

        fprintf(stdout," </transition>\n");
        
}
void print_conditions(Cond *cond,int ncond){
        int i;
        int cnt = 0;
        if (ncond <= 0)
                return;
        /* Print all assignments together, all guards together */
        cnt = 0;
        for (i =0;i<ncond; ++i)
                if (strcmp(cond[i].kind,"guard")==0){
                        if (cnt >= 1)
                                fprintf(stdout, " and ");
                        if (cnt == 0){
                                
                                fprintf(stdout, "<label kind=");
                                fprintf(stdout," \"guard\">");
                                cnt = 1;

                        }
                        fprintf(stdout," %s",cond[i].pred);
                }
        if (cnt > 0){
                fprintf(stdout, "</label>");
        }

        cnt = 0;
        for (i =0;i<ncond; ++i)
                if (strcmp(cond[i].kind,"synchronisation")==0){
                        if (cnt >= 1)
                                myassert(0, "Dont know how to handle");
                        if (cnt == 0){
                                
                                fprintf(stdout, "<label kind=");
                                fprintf(stdout," \"synchronisation\">");
                                cnt = 1;

                        }
                        fprintf(stdout," %s",cond[i].pred);
                }
        if (cnt > 0){
                fprintf(stdout, "</label>");
        }


        cnt = 0;
        for (i =0;i<ncond; ++i)
                if (strcmp(cond[i].kind,"assignment")==0){
                        if (cnt >= 1)
                                fprintf(stdout, " , ");
                                
                        if (cnt == 0) {
                                fprintf(stdout,
                                        "<label kind= \"assignment\"> ");
                                        cnt = 1;
                        }
                        fprintf(stdout," %s",cond[i].pred);

                }
        if (cnt > 0 ){
                fprintf(stdout, "</label>");
        }

        cnt = 0;
        for (i =0;i<ncond; ++i)
                if (strcmp(cond[i].kind,"invariant")==0){
                        if (cnt >= 1)
                                fprintf(stdout, " and ");
                        if (cnt == 0){
                                
                                fprintf(stdout, "<label kind=");
                                fprintf(stdout," \"invariant\">");
                                cnt = 1;

                        }
                        fprintf(stdout," %s",cond[i].pred);
                }
        if (cnt > 0){
                fprintf(stdout, "</label>");
        }
 
}
int read_known_costs(){
        boolean match_found=false;
        FILE *fin;

        const char *cur_fname = CUR_FNAME;
        max_n = 0;
        known=(struct cost_cache*)mycalloc(MAX_FUNC_CNT, sizeof(struct cost_cache));

        fin=fopen(COSTS_FILE,"r");
        if (fin==NULL){
                fprintf (stderr,"COSTS_FILE could not be opened");
                exit (1);
        }
        while (fin){
                int ret=fscanf(fin,"%s %Ld",
                                known[max_n].fname,
                                &(known[max_n].cost));
                if (ret == EOF)
                        break;
                if (strcmp(known[max_n].fname,cur_fname)==0)
                        match_found = true;
                max_n ++ ;
                myassert(max_n < MAX_FUNC_CNT, 
                        "Buffer overflow danger");

        }
        fclose(fin);

        if (match_found) return MATCH_FOUND ;
        else return NOT_FOUND;
        
}
long long int already_known(const char *fname){
        int i;
        for (i=0;i<max_n;++i){
                if (strcmp(fname, known[i].fname) == 0)
                        return known[i].cost;
        }
        return -1;
}
long long int Farg(rtx insn){
        return 100;
}
const char *Fname(rtx insn){
        rtx body = PATTERN(insn);
        rtx call = body;
        const char *fname = "unknown_FP";

        if (GET_CODE(body) == SET){
        /* Function with a return value */
                call=XEXP(body,1);
        }


        if (GET_CODE(XEXP(XEXP(call,0),0)) == SYMBOL_REF)
                fname = XSTR(XEXP(XEXP(call,0),0),0);
        return fname;
}

int get_frequency(basic_block bb){

/*        return (bb->loop_depth*LOOP_DEPTH + 1.0)**/
/*                global_freq_max*bb->frequency/BB_FREQ_MAX;*/
        return (bb->loop_depth)==0?1:
                ((int) (pow((double)LOOP_DEPTH,(double)bb->loop_depth)));
        
}

void update_with_frequency(timeVal *tv, int freq){
        
        FuncList *flist;
        if (tv == NULL)
                return;


        tv->int_cost *= freq;

        flist = tv->func_cost;
        while (flist){
                
                flist->count *= freq;
                flist = flist->next;
        }

        return;

}
boolean useless_insn(rtx insn){

       return ( (INSN_DELETED_P(insn)) ||
                ( GET_CODE(insn)!= INSN && 
                  GET_CODE (insn) != CALL_INSN &&
                  GET_CODE (insn) != JUMP_INSN)
              );
}

boolean call_insn(rtx insn){
       return (GET_CODE (insn) == CALL_INSN);
}
void print_cost(timeVal * cost){
/* Prints to the standard output */

        int cc = 0; /* component count */

        fprintf(stdout,"%s ",CUR_FNAME);
        if (cost == NULL) {
                fprintf (stdout,"(empty)");
                return ;
        } /* cost == NULL */

        if (cost->int_cost != 0){
                fprintf(stdout, " %Ld ",cost->int_cost);
                cc ++;
        } /* int_cost != 0 */

        if (cost->func_cost != NULL){

                FuncList *flist = cost->func_cost;

                while (flist){

                        if (cc != 0)
                                fprintf(stdout, " + ");
                        
                        myassert ((flist->count != 0), 
                                        "Count cannot be zero");
                        fprintf(stdout, "%d * %s",
                                        flist->count, flist->fname) ;
                        flist = flist->next;

                } /* while (flist) */
        } /* func_cost != NULL */
        fprintf(stdout, "\n");

        return;
/* Last line of this function */
}

void deallocate_timeVal(timeVal *tv){

        if (tv != NULL){

                deallocate_list(tv->func_cost);

        }

        return;
}

void deallocate_list(FuncList *flist){
/* DO NOT DELETE the function name. We do not allocate it. */
        if (flist){

                deallocate_list(flist->next);
/*                free(flist);*/
/* We are not freeing the memory as we are using xmalloc */

        } /* if (flist) */

        return;
}
#if 0
FuncList* add_to_flist(FuncList *flist, char *fname){
        
        FuncList *first = flist;

        while (flist && strcmp(flist->fname, fname)!=0){

                flist = flist->next;
                
        } /* while */

        if (flist != NULL){

                flist->count++;
                return flist;

        } else {
                
                FuncList *newFlist = create_flist(fname,1,first);
                return newFlist;
        }

}
#endif
FuncList* create_flist(const char *fname, int c, FuncList *first){

        FuncList *newFlist = (FuncList *)mycalloc(1,sizeof(FuncList));
        newFlist->fname = fname;
        newFlist->count = c;
        newFlist->next = first;

        return newFlist;
}

timeVal *make_timeVal_from_int(long long int t){

        timeVal *tv = create_timeVal();

        tv->int_cost = t;
        return tv;

}
timeVal *make_timeVal_from_func(FuncList *flist){

        timeVal *tv = create_timeVal();

        tv->func_cost = flist;
        return tv;

}

void add_to_timeVal(timeVal *dest, timeVal *new_val){
        
        myassert(dest != NULL, "Argument dest cannot be null");

        dest->int_cost += new_val ->int_cost;
        dest->func_cost = add_Flists(dest->func_cost, new_val->func_cost);

        return;
}

FuncList *add_Flists(FuncList *f1, FuncList *src){
/* f1 gets destroyed -- All those elements of f2 which are present in f1
 * have their frequencies modified to the sum of the frequency of f1 and
 * f2. */
        
FuncList *newList ;
FuncList * f2 = src;

newList = f1;

while (f2 && f2->count != 0){

        FuncList *temp_f1 = f1;

        while(temp_f1){

                if (strcmp(temp_f1->fname,f2->fname) == 0){

                        temp_f1->count += f2->count;
                        break;

                } 

                temp_f1 = temp_f1->next;
        }

        if (temp_f1 == NULL){

                newList = create_flist(f2->fname,
                                f2->count,
                                newList);
                
        }

       f2 = f2->next;
}

return newList;
}

timeVal* create_timeVal(){
        timeVal *new_tv;

        new_tv = (timeVal *)mycalloc(1,sizeof(timeVal));
        return new_tv;

}

void * mycalloc(int nmem, int nsize){
        void *vt = xcalloc(nmem , nsize);
/*        memset(vt,0,nmem*nsize);*/

        if (vt == NULL){
                myassert(false,"Unable to allocate memory.");
        }
        return vt;
}
void print_wl(worklist *wl){
        while (wl){
                fprintf(stdout,"%d ", BBID(wl->bb));
                wl = wl->next;
        }
        fprintf(stdout,"\n");
        return ;
}

int can_loose_intr(int bb){
        return (int)((return_bb_cost(bb)*FACTOR/BASE)/TIMER_PERIOD);
}
boolean invalid_bb(basic_block bb){
        return (bb->index < 0);
}
boolean is_leaf(basic_block bb){
        edge e;
        if (bb->succ == NULL)
                return true;
        for (e=bb->succ;e!=NULL;e=e->succ_next)
            if (!invalid_bb(e->dest))
                    return false;
        return true;
}

int make_timer_interaction_cond(int noc, Cond **argCnd){
        /* santized */
        /* nc = number of other conditions that will be added later. */
        Cond *cond;

        cond = (Cond *)mycalloc(noc,sizeof(Cond));
        *argCnd = cond;
        return 0;
}


int make_loop_cond(Cond **argCnd){
/* It waits for time to elapse and once time has elapsed, it will
 * reset_input.
 */
        /* We can reuse the same cond for each call */
        static Cond *cond;
        static int ci=0;
        if (cond != NULL){
                *argCnd = cond;
                return  ci;
        }

        cond = (Cond *)mycalloc(3,sizeof(Cond));
/*        cond[ci].kind = "assignment";*/
/*        s = (char *)mycalloc(100,sizeof(char));*/
/*        sprintf(s, "lost_ticks := %d",*/
/*                WAIT_INCR);*/
/*        cond[ci++].pred = s;*/
        
/*        cond[ci].kind = "synchronisation";*/
/*        cond[ci++].pred = "awake_timer!";*/

        cond[ci].kind = "guard";
        cond[ci++].pred = "T_s0 &gt;= T_a";

        cond[ci].kind = "synchronisation";
        cond[ci++].pred = "input_reset!";

        cond[ci].kind = "guard";
        cond[ci++].pred = "input == 0";


        *argCnd = cond;
        return ci;

}

void make_edges_for_end_of_processing_to_loop_back(
                int src1, 
                int src2,
                int dest1,
                int dest2,
                int dest3,
                boolean last_automata){
        /* dest1 --> The destination for all but the last automata, if it
         *           is not timeout yet.
         * dest2 --> The destination of the last automata, if it is not
         *           timeout yet.
         * dest3 --> The destination of either automata, if timeout.
         */
        int ci, count;
        Cond *cond;
        int src;

        count = 0;
        src = src1;
        while(count < 2){
                ci = 0;
                cond = (Cond *)mycalloc(3,sizeof(Cond));

                cond[ci].kind = "guard";
                cond[ci++].pred = "input &gt;= 1";
#ifdef INTR_TICKS
                cond[ci].kind = "guard";
                s = (char *)mycalloc(100,sizeof(char));
                sprintf(s, "T_a &lt;= intr_ticks * %Ld",
                        TIMER_PERIOD);
                cond[ci++].pred = s;
#endif
                cond[ci].kind = "guard";
                cond[ci++].pred = "T_s0 &lt; T_o";

                if (!last_automata){
                        create_edge(src, dest1, cond, ci);
                }
                else
                        create_edge(src, dest2, cond, ci);

                /* c */
                ci = 0;
                cond = (Cond *)mycalloc(2,sizeof(Cond));

                cond[ci].kind = "guard";
                cond[ci++].pred = "T_s0 &gt;= T_o";

                create_edge(src,
                            dest3,
                            cond,ci);

                ci = 0 ;
                cond = (Cond *)mycalloc(2,sizeof(Cond));

                cond[ci].kind = "guard";
                cond[ci++].pred = "T_s0 &lt; T_a";

                create_edge(src,
                            TEMP1,
                            cond,ci);

                count ++;
                if (count == 1)
                        src = src2;

        } /* for tst */

        /* d */
        ci = make_loop_cond(&cond);
        create_edge(src1, src2,
                        cond,ci);
        return;
}
int tdiCount = 1;
void timer_default_increment(int bb,int automata, Cond *cond){
        /* sanitized */
        char *s ;
        s = (char *)mycalloc(100,sizeof(char));
        cond[0].kind = "guard";
        sprintf(s,"T_s%d &gt;= (Ctr%dA2 * timer_period)",
                        automata,
                        automata);
        cond[0].pred = s;

        return;
}
void timer_default_increment2(int bb,int automata, Cond *cond){
        /* sanitized */
        char *s ;
        s = (char *)mycalloc(100,sizeof(char));
        cond[0].kind = "guard";
        sprintf(s,"T_s%d &gt;= %Ld",
                        automata,
                        return_bb_max_cost(bb)*FACTOR/BASE);
        cond[0].pred = s;

        return;
}
long long int get_func_cost(const char *const fname){
        int i;
        myassert(fname!=NULL,
                        "Can't find cost of empty function");
        for (i=0;i<max_n;++i){
                if (strcmp(known[i].fname,fname)==0)
                        return known[i].cost;
        }
        return -1;
        
}

void create_synchronization(Cond *cond, const char * const s){

                        cond[0].kind = "synchronisation";
                        cond[0].pred = s;
                        return;
}

void create_assignment(Cond *cond, const char * const s){

                        cond[0].kind = "assignment";
                        cond[0].pred = s;
                        return;
}
void create_guard(Cond *cond, const char * const s){

                        cond[0].kind = "guard";
                        cond[0].pred = s;
                        return;
}
/*
JUMP_INSN
CALL_INSN
RETURN
MEM*/
