#include <unistd.h>
#include <stdio.h>
#include <math.h>
#include <assert.h>
#include <sys/time.h>
#define FIRST 99999
int getopt(int argc, char * const argv[], const char *optstring); 

extern char *optarg;
extern int optind, opterr, optopt;
int total = 0;

               
void generate_next_node(int i, long long unsigned int wait);
void generate_next_edge(int i, int j, long long unsigned int wait);
void set_init(int);
void prologue();
void epilogue();
void create_and_print_node(int,long long unsigned int);
void create_input_edge(int src,int dest, char *kind, char *pred);
void create_edge_plain(int src,int dest, char *kind, char *pred);
void create_and_print_last_node(int bb_no, double wait);
void generate_last_edge(int ,int );
main(int argc, char *argv[]){
        int option;
        struct timeval tv;
        double seed = 0.0;
        int count = 100; /* default */
        long long unsigned int *wait_list;


        while ((option=getopt(argc,argv,"n:p:c:"))!= -1){
                switch(option){
                        case 'c':
                                sscanf(optarg,"%d",&count);
                                break;
                        case '?': exit(1);
                }

        } 

        wait_list = (long long unsigned int*) calloc(count,
                                sizeof(long long unsigned int));
        gettimeofday(&tv,NULL);
        seed = 0.49 * sin(tv.tv_usec) + 0.50;    //  0.01 <= seed <= 0.99

        prologue();

        int i;
        scanf("%Lu",&wait_list[0]);
        /* the input ipt is in cycles */
#define FACTOR 1
        wait_list[0] *= FACTOR;
        for (i=1;i<count; ++i){
                long long unsigned int t;
                scanf("%Lu",&t);
                wait_list[i] = wait_list[i-1] + t * FACTOR;
        }

        for(i=0;i<count;++i){
                create_and_print_node(i,wait_list[i]);
        }
        create_and_print_last_node(i,wait_list[i-1]);

        set_init(FIRST);
 
        create_edge_plain(FIRST,0,"assignment", "input := 1");
        for (i=0;i<count-1; ++i){
                generate_next_edge(i,i+1,wait_list[i]);
        }
        generate_last_edge(i,i+1);
/*        generate_next_edge(i,FIRST,wait_list[i]);*/
        epilogue();
}
void set_init(int nd_no){
        fprintf(stdout,"<init ref=\"Aid%d\" />\n",nd_no);   
}                                                          


void create_and_print_last_node(int bb_no, double wait){

        fprintf(stdout,
               "<location id=\"Aid%d\" > <name>%s%d</name> ",
               bb_no,"Aid",bb_no);

        fprintf(stdout, "<label kind=");
        fprintf(stdout," \"invariant\"> true</label>");

        fprintf(stdout,"</location>\n");
        return;
}

void generate_last_edge(int i, int j){
        create_edge_plain(i,j,"guard","true");
}

void create_and_print_node(int bb_no, long long unsigned int wait){     
                                                                                        

        fprintf(stdout,                                       
               "<location id=\"Aid%d\" > <name>%s%d</name> ",    
               bb_no,"Aid",bb_no);                              

        fprintf(stdout, "<label kind=");  
        fprintf(stdout," \"invariant\"> T_a &lt;=%Lu</label>",(long long unsigned int)wait);    

        fprintf(stdout,"</location>\n");                                                
        return;                                                                         
}                                                                                       
void generate_next_edge(int i, int j, long long unsigned int wait){
        char *s=(char *)calloc(100,sizeof(char));
        sprintf(s,"T_a &gt;= %Lu",(long long unsigned int)wait);
        create_input_edge(i,j,"guard",s);
        //create_edge(i,j,"assignment","input := 1");
}
void create_input_edge(int src, int dest, char *kind, char *pred){
        assert(strcmp(kind,"guard")==0);
fprintf(stdout,
"<transition> "
"<source ref=\"Aid%d\"/><target ref=\"Aid%d\"/>"
"<label kind=\"%s\" >"
"%s"
"</label> "
"<label kind=\"synchronisation\" >input_reset?</label> "
"<label kind=\"assignment\" >input+=1</label> "
" </transition>\n",src,dest,kind,pred);


fprintf(stdout,
"<transition> "
"<source ref=\"Aid%d\"/><target ref=\"Aid%d\"/>"
"<label kind=\"%s\" >"
"%s"
"</label> "
"<label kind=\"synchronisation\" >input_reset_a0?</label> "
"<label kind=\"assignment\" >input:=1</label> "
" </transition>\n",src,dest,kind,pred);
}
void create_edge_plain(int src, int dest, char *kind, char *pred){
fprintf(stdout,
"<transition>"
"<source ref=\"Aid%d\"/><target ref=\"Aid%d\"/>"
"<label kind=\"%s\" >%s</label> "
"</transition>\n",src,dest,kind,pred);
}
void prologue(){
fprintf(stdout,                                                      
"<template>"
"<name>attacker</name><parameter></parameter>"
"<location id=\"Aid%d\"><name >start_evil</name></location>",
FIRST
);

}
void epilogue(){
fprintf(stdout," </template>\n ");
}
